class UDHUDWar extends UDHUD;

simulated function DrawCrosshair(Canvas C)
{
    local float NormalScale;
    local int i, CurrentCrosshair;
    local float OldScale,OldW, CurrentCrosshairScale;
    local color CurrentCrosshairColor;
    local SpriteWidget CHtexture;

    if ( PawnOwner.bSpecialCrosshair )
    {
        PawnOwner.SpecialDrawCrosshair( C );
        return;
    }

    if (!bCrosshairShow)
        return;

    if ( bUseCustomWeaponCrosshairs && (PawnOwner != None) && (PawnOwner.Weapon != None) )
    {
        CurrentCrosshair = PawnOwner.Weapon.CustomCrosshair;
        if (CurrentCrosshair == -1 || CurrentCrosshair == Crosshairs.Length)
        {
            CurrentCrosshair = CrosshairStyle;
            CurrentCrosshairColor = CrosshairColor;
            CurrentCrosshairScale = CrosshairScale;
        }
        else
        {
            CurrentCrosshairColor = PawnOwner.Weapon.CustomCrosshairColor;
            CurrentCrosshairScale = PawnOwner.Weapon.CustomCrosshairScale;
            if ( PawnOwner.Weapon.CustomCrosshairTextureName != "" )
            {
                if ( PawnOwner.Weapon.CustomCrosshairTexture == None )
                {
                    PawnOwner.Weapon.CustomCrosshairTexture = Texture(DynamicLoadObject(PawnOwner.Weapon.CustomCrosshairTextureName,class'Texture'));
                    if ( PawnOwner.Weapon.CustomCrosshairTexture == None )
                    {
                        log(PawnOwner.Weapon$" custom crosshair texture not found!");
                        PawnOwner.Weapon.CustomCrosshairTextureName = "";
                    }
                }
                CHTexture = Crosshairs[0];
                CHTexture.WidgetTexture = PawnOwner.Weapon.CustomCrosshairTexture;
            }
        }
    }
    else
    {
        CurrentCrosshair = CrosshairStyle;
        CurrentCrosshairColor = CrosshairColor;
        CurrentCrosshairScale = CrosshairScale;
    }

    CurrentCrosshair = Clamp(CurrentCrosshair, 0, Crosshairs.Length - 1);

    NormalScale = Crosshairs[CurrentCrosshair].TextureScale;
    if ( CHTexture.WidgetTexture == None )
        CHTexture = Crosshairs[CurrentCrosshair];
    CHTexture.TextureScale *= 0.5 * CurrentCrosshairScale;

    for( i = 0; i < ArrayCount(CHTexture.Tints); i++ )
        CHTexture.Tints[i] = CurrentCrossHairColor;

    if ( LastPickupTime > Level.TimeSeconds - 0.4 )
    {
        if ( LastPickupTime > Level.TimeSeconds - 0.2 )
            CHTexture.TextureScale *= (1 + 5 * (Level.TimeSeconds - LastPickupTime));
        else
            CHTexture.TextureScale *= (1 + 5 * (LastPickupTime + 0.4 - Level.TimeSeconds));
    }
    OldScale = HudScale;
    HudScale=1;
    OldW = C.ColorModulate.W;
    C.ColorModulate.W = 1;
    DrawSpriteWidget (C, CHTexture);
    C.ColorModulate.W = OldW;
    HudScale=OldScale;
    CHTexture.TextureScale = NormalScale;

    DrawEnemyName(C);
}

defaultproperties
{
}
