class UDScoreBoardSumo extends ScoreBoardDeathMatch;

var localized string LivesText;
var plane FullOn, GrayedOut;

simulated event UpdateScoreBoard(Canvas Canvas)
{
    local PlayerReplicationInfo PRI, OwnerPRI;
    local int i, FontReduction, OwnerPos, NetXPos, PlayerCount,HeaderOffsetY,HeadFoot, MessageFoot, PlayerBoxSizeY, BoxSpaceY, NameXPos, BoxTextOffsetY, OwnerOffset, ScoreXPos, DeathsXPos, BoxXPos, TitleYPos, BoxWidth;
    local float XL,YL, MaxScaling;
    local float deathsXL, scoreXL, netXL, MaxNamePos;
    local string playername[MAXPLAYERS];
    local bool bNameFontReduction;
    local plane OldColorModulate;


    OldColorModulate = Canvas.ColorModulate;

    OwnerPRI = PlayerController(Owner).PlayerReplicationInfo;
    for (i=0; i<GRI.PRIArray.Length; i++)
    {
        PRI = GRI.PRIArray[i];
        if ( !PRI.bOnlySpectator && (!PRI.bIsSpectator || PRI.bWaitingPlayer) )
        {
            if ( PRI == OwnerPRI )
                OwnerOffset = i;
            PlayerCount++;
        }
    }
    PlayerCount = Min(PlayerCount,MAXPLAYERS);

    // Select best font size and box size to fit as many players as possible on screen
    Canvas.Font = HUDClass.static.GetMediumFontFor(Canvas);
    Canvas.StrLen("Test", XL, YL);
    BoxSpaceY = 0.25 * YL;
    PlayerBoxSizeY = 1.5 * YL;
    HeadFoot = 5*YL;
    MessageFoot = 1.5 * HeadFoot;
    if ( PlayerCount > (Canvas.ClipY - 1.5 * HeadFoot)/(PlayerBoxSizeY + BoxSpaceY) )
    {
        BoxSpaceY = 0.125 * YL;
        PlayerBoxSizeY = 1.25 * YL;
        if ( PlayerCount > (Canvas.ClipY - 1.5 * HeadFoot)/(PlayerBoxSizeY + BoxSpaceY) )
        {
            if ( PlayerCount > (Canvas.ClipY - 1.5 * HeadFoot)/(PlayerBoxSizeY + BoxSpaceY) )
                PlayerBoxSizeY = 1.125 * YL;
            if ( PlayerCount > (Canvas.ClipY - 1.5 * HeadFoot)/(PlayerBoxSizeY + BoxSpaceY) )
            {
                FontReduction++;
                Canvas.Font = GetSmallerFontFor(Canvas,FontReduction);
                Canvas.StrLen("Test", XL, YL);
                BoxSpaceY = 0.125 * YL;
                PlayerBoxSizeY = 1.125 * YL;
                HeadFoot = 5*YL;
                if ( PlayerCount > (Canvas.ClipY - HeadFoot)/(PlayerBoxSizeY + BoxSpaceY) )
                {
                    FontReduction++;
                    Canvas.Font = GetSmallerFontFor(Canvas,FontReduction);
                    Canvas.StrLen("Test", XL, YL);
                    BoxSpaceY = 0.125 * YL;
                    PlayerBoxSizeY = 1.125 * YL;
                    HeadFoot = 5*YL;
                    if ( (Canvas.ClipY >= 768) && (PlayerCount > (Canvas.ClipY - HeadFoot)/(PlayerBoxSizeY + BoxSpaceY)) )
                    {
                        FontReduction++;
                        Canvas.Font = GetSmallerFontFor(Canvas,FontReduction);
                        Canvas.StrLen("Test", XL, YL);
                        BoxSpaceY = 0.125 * YL;
                        PlayerBoxSizeY = 1.125 * YL;
                        HeadFoot = 5*YL;
                    }
                }
            }
        }
    }
    if ( Canvas.ClipX < 512 )
        PlayerCount = Min(PlayerCount, 1+(Canvas.ClipY - HeadFoot)/(PlayerBoxSizeY + BoxSpaceY) );
    else
        PlayerCount = Min(PlayerCount, (Canvas.ClipY - HeadFoot)/(PlayerBoxSizeY + BoxSpaceY) );
    if ( OwnerOffset >= PlayerCount )
        PlayerCount -= 1;

    if ( FontReduction > 2 )
        MaxScaling = 3;
    else
        MaxScaling = 2.125;
    PlayerBoxSizeY = FClamp((1+(Canvas.ClipY - 0.67 * MessageFoot))/PlayerCount - BoxSpaceY, PlayerBoxSizeY, MaxScaling * YL);

    bDisplayMessages = (PlayerCount <= (Canvas.ClipY - MessageFoot)/(PlayerBoxSizeY + BoxSpaceY));
    HeaderOffsetY = 3 * YL;
    BoxWidth = 0.9375 * Canvas.ClipX;
    BoxXPos = 0.5 * (Canvas.ClipX - BoxWidth);
    BoxWidth = Canvas.ClipX - 2*BoxXPos;
    NameXPos = BoxXPos + 0.0625 * BoxWidth;
    ScoreXPos = BoxXPos + 0.5 * BoxWidth;
    DeathsXPos = BoxXPos + 0.6875 * BoxWidth;
    NetXPos = BoxXPos + 0.8125 * BoxWidth;

    // draw background boxes
    Canvas.Style = ERenderStyle.STY_Alpha;
    Canvas.DrawColor = HUDClass.default.WhiteColor * 0.5;
    for ( i=0; i<PlayerCount; i++ )
    {
        Canvas.SetPos(BoxXPos, HeaderOffsetY + (PlayerBoxSizeY + BoxSpaceY)*i);
        Canvas.DrawTileStretched( BoxMaterial, BoxWidth, PlayerBoxSizeY);
    }
    Canvas.Style = ERenderStyle.STY_Translucent;

    // draw title
    Canvas.Style = ERenderStyle.STY_Normal;
    DrawTitle(Canvas, HeaderOffsetY, (PlayerCount+1)*(PlayerBoxSizeY + BoxSpaceY), PlayerBoxSizeY);

    // Draw headers
    TitleYPos = HeaderOffsetY - 1.25*YL;
    Canvas.StrLen(PointsText, ScoreXL, YL);
    Canvas.StrLen(LivesText, DeathsXL, YL);

    Canvas.DrawColor = HUDClass.default.WhiteColor;
    Canvas.SetPos(NameXPos, TitleYPos);
    Canvas.DrawText(PlayerText,true);
    Canvas.SetPos(ScoreXPos - 0.5*ScoreXL, TitleYPos);
    Canvas.DrawText(PointsText,true);
    Canvas.SetPos(DeathsXPos - 0.5*DeathsXL, TitleYPos);
    Canvas.DrawText(LivesText,true);

    // draw player names
    MaxNamePos = 0.9 * (ScoreXPos - NameXPos);
    for ( i=0; i<PlayerCount; i++ )
    {
        playername[i] = GRI.PRIArray[i].PlayerName;
        Canvas.StrLen(playername[i], XL, YL);
        if ( XL > MaxNamePos )
        {
            bNameFontReduction = true;
            break;
        }
    }
    if ( !bNameFontReduction && (OwnerOffset >= PlayerCount) )
    {
        playername[OwnerOffset] = GRI.PRIArray[OwnerOffset].PlayerName;
        Canvas.StrLen(playername[OwnerOffset], XL, YL);
        if ( XL > MaxNamePos )
            bNameFontReduction = true;
    }

    if ( bNameFontReduction )
        Canvas.Font = GetSmallerFontFor(Canvas,FontReduction+1);
    for ( i=0; i<PlayerCount; i++ )
    {
        playername[i] = GRI.PRIArray[i].PlayerName;
        Canvas.StrLen(playername[i], XL, YL);
        if ( XL > MaxNamePos )
            playername[i] = left(playername[i], MaxNamePos/XL * len(PlayerName[i]));
    }
    if ( OwnerOffset >= PlayerCount )
    {
        playername[OwnerOffset] = GRI.PRIArray[OwnerOffset].PlayerName;
        Canvas.StrLen(playername[OwnerOffset], XL, YL);
        if ( XL > MaxNamePos )
            playername[OwnerOffset] = left(playername[OwnerOffset], MaxNamePos/XL * len(PlayerName[OwnerOffset]));
    }

    Canvas.Style = ERenderStyle.STY_Normal;
    Canvas.DrawColor = HUDClass.default.WhiteColor;
    Canvas.SetPos(0.5 * Canvas.ClipX, HeaderOffsetY + 4);
    BoxTextOffsetY = HeaderOffsetY + 0.5 * (PlayerBoxSizeY - YL);

    Canvas.DrawColor = HUDClass.default.WhiteColor;
    for ( i=0; i<PlayerCount; i++ )
        if ( i != OwnerOffset )
        {
            if (GRI.PRIArray[i].bOutOfLives)
                Canvas.ColorModulate = GrayedOut;
            else
                Canvas.ColorModulate = FullOn;

            Canvas.SetPos(NameXPos, (PlayerBoxSizeY + BoxSpaceY)*i + BoxTextOffsetY);
            Canvas.DrawText(playername[i],true);
        }
    if ( bNameFontReduction )
        Canvas.Font = GetSmallerFontFor(Canvas,FontReduction);

    // draw scores
    Canvas.DrawColor = HUDClass.default.WhiteColor;
    for ( i=0; i<PlayerCount; i++ )
        if ( i != OwnerOffset )
        {
            if (GRI.PRIArray[i].bOutOfLives)
                Canvas.ColorModulate = GrayedOut;
            else
                Canvas.ColorModulate = FullOn;

            Canvas.SetPos(ScoreXPos, (PlayerBoxSizeY + BoxSpaceY)*i + BoxTextOffsetY);
            Canvas.DrawText(int(GRI.PRIArray[i].Score),true);
        }

    // draw deaths
    Canvas.DrawColor = HUDClass.default.WhiteColor;
    for ( i=0; i<PlayerCount; i++ )
        if ( i != OwnerOffset )
        {
            if (GRI.PRIArray[i].bOutOfLives)
            {
                Canvas.ColorModulate = GrayedOut;
                Canvas.StrLen(OutText,Xl,Yl);
                Canvas.SetPos(DeathsXPos - (XL/2), (PlayerBoxSizeY + BoxSpaceY)*i + BoxTextOffsetY);
                Canvas.DrawText(OutText,true);
            }
            else
            {
                Canvas.ColorModulate = FullOn;
                Canvas.SetPos(DeathsXPos, (PlayerBoxSizeY + BoxSpaceY)*i + BoxTextOffsetY);
                Canvas.DrawText(int(GRI.MaxLives - GRI.PRIArray[i].Deaths),true);
            }
        }

    // draw owner line
    if ( OwnerOffset >= PlayerCount )
    {
        OwnerPos = (PlayerBoxSizeY + BoxSpaceY)*PlayerCount + BoxTextOffsetY;
        // draw extra box
        Canvas.Style = ERenderStyle.STY_Alpha;
        Canvas.DrawColor = HUDClass.default.TurqColor * 0.5;
        Canvas.SetPos(BoxXPos, HeaderOffsetY + (PlayerBoxSizeY + BoxSpaceY)*PlayerCount);
        Canvas.DrawTileStretched( BoxMaterial, BoxWidth, PlayerBoxSizeY);
        Canvas.Style = ERenderStyle.STY_Normal;
    }
    else
        OwnerPos = (PlayerBoxSizeY + BoxSpaceY)*OwnerOffset + BoxTextOffsetY;

    if (GRI.PRIArray[i].bOutOfLives)
        Canvas.ColorModulate = GrayedOut;
    else
        Canvas.ColorModulate = FullOn;

    Canvas.DrawColor = HUDClass.default.GoldColor;
    Canvas.SetPos(NameXPos, OwnerPos);
    if ( bNameFontReduction )
        Canvas.Font = GetSmallerFontFor(Canvas,FontReduction+1);
    Canvas.DrawText(playername[OwnerOffset],true);
    if ( bNameFontReduction )
        Canvas.Font = GetSmallerFontFor(Canvas,FontReduction);
    Canvas.SetPos(ScoreXPos, OwnerPos);
    Canvas.DrawText(int(GRI.PRIArray[OwnerOffset].Score),true);

    if ( GRI.PRIArray[OwnerOffset].bOutOfLives )
    {
        Canvas.StrLen(OutText,Xl,Yl);
        Canvas.SetPos(DeathsXPos-(XL/2), OwnerPos);
        Canvas.DrawText(OutText,true);
    }
    else
    {
        Canvas.SetPos(DeathsXPos, OwnerPos);
        Canvas.DrawText(int(GRI.MaxLives-GRI.PRIArray[OwnerOffset].Deaths),true);
    }

    if ( Level.NetMode == NM_Standalone )
        return;

    Canvas.StrLen(NetText, NetXL, YL);
    Canvas.DrawColor = HUDClass.default.WhiteColor;
    Canvas.SetPos(NetXPos + 0.5*NetXL, TitleYPos);
    Canvas.DrawText(NetText,true);

    for ( i=0; i<GRI.PRIArray.Length; i++ )
        PRIArray[i] = GRI.PRIArray[i];
    DrawNetInfo(Canvas,FontReduction,HeaderOffsetY,PlayerBoxSizeY,BoxSpaceY,BoxTextOffsetY,OwnerOffset,PlayerCount,NetXPos);
    DrawMatchID(Canvas,FontReduction);
}

simulated function bool InOrder( PlayerReplicationInfo P1, PlayerReplicationInfo P2 )
{
    if( P1.bOnlySpectator )
    {
        if( P2.bOnlySpectator )
            return true;
        else
            return false;
    }
    else if ( P2.bOnlySpectator )
        return true;

    if (P1.Deaths > P2.Deaths)
        return false;

    if (P1.Deaths == P2.Deaths)
    {
        if (P1.Score < P2.Score)
            return false;

        if ( (P1.Score == P2.Score) && (PlayerController(P2.Owner) != None) && (Viewport(PlayerController(P2.Owner).Player) != None) )
            return false;
    }

    return true;
}

defaultproperties
{
     LivesText="LIVES"
     FullOn=(W=1.000000,X=1.000000,Y=1.000000,Z=1.000000)
     GrayedOut=(W=0.750000,X=0.750000,Y=0.750000,Z=0.750000)
}
