class UDStuntVehicle extends UDVech;

var() float TierOneThresh;
var() float TierTwoThresh;
var() float TierThreeThresh;
var() float TierFourThresh;
var() float TierFiveThresh;

var() float BaseScoreBonus;

var() float StuntScoreholder;

var() int NetStartingNow;

var() bool bIsFive;
var() bool bIsFour;
var() bool bIsThree;
var() bool bIsTwo;
var() bool bIsOne;

var() float InAirSpinPositive;
var() float InAirRollPositive;
var() float InAirPitchPositive;

simulated event OnDaredevil()
{
    local PlayerController PC;
    local TeamPlayerReplicationInfo PRI;
    PC = PlayerController(Controller);
    if (PC != None)
    {

	if(InAirSpin < 0.00000000)
	       InAirSpinPositive=-InAirSpin;
	else
	       InAirSpinPositive=InAirSpin;

	if(InAirPitch < 0.00000000)
	        InAirPitchPositive=-InAirPitch;
	else
	        InAirPitchPositive=InAirPitch;

	if(InAirRoll < 0.00000000)
	        InAirRollPositive=-InAirRoll;
	else
	        InAirRollPositive=InAirRoll;

    //Determines what threshold was passed in stunt
    if (((InAirSpinPositive / 360) + (InAirPitchPositive / 360) + (InAirRollPositive / 360)) > TierFiveThresh)
        bIsFive = true;
    else if (((InAirSpinPositive / 360) + (InAirPitchPositive / 360) + (InAirRollPositive / 360)) > TierFourThresh)
        bIsFour = true;
    else if (((InAirSpinPositive / 360) + (InAirPitchPositive / 360) + (InAirRollPositive / 360)) > TierThreeThresh)
        bIsThree = true;
    else if (((InAirSpinPositive / 360) + (InAirPitchPositive / 360) + (InAirRollPositive / 360)) > TierTwoThresh)
        bIsTwo = true;
    else if (((InAirSpinPositive / 360) + (InAirPitchPositive / 360) + (InAirRollPositive / 360)) > TierOneThresh)
        bIsOne = true;
    ///////////////////

        if (Level.NetMode != NM_DedicatedServer)
        {
             if( NetStartingNow == 0)
             {
                  NetStartingNow+=1;
            	  return;
             }

             if(bIsOne==True)
             {
                  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 0, None, None, self);
            	  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 1, None, None, self);
             }
             else if(bIsTwo==True)
             {
                  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 2, None, None, self);
            	  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 1, None, None, self);
             }
             else if(bIsThree==True)
             {
                  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 3, None, None, self);
            	  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 1, None, None, self);
             }
             else if(bIsFour==True)
             {
                  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 4, None, None, self);
            	  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 1, None, None, self);
             }
             else if(bIsFive==True)
             {
                  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 5, None, None, self);
            	  PC.ReceiveLocalizedMessage(DaredevilMessageClass, 1, None, None, self);
             }
        }

        if (Role == ROLE_Authority)
        {

             if( NetStartingNow == 0)
             {
                  NetStartingNow+=1;
            	  return;
             }
             PRI = TeamPlayerReplicationInfo(PC.PlayerReplicationInfo);

             StuntScoreHolder=0;

             if(PRI != None)
             {
            	  PRI.DaredevilPoints += DaredevilPoints;

                  /*
                  Trick System:
                  (Number Rotations X + Number Rotations Y + Number Rotations Z)
                                               *
                  (Degrees Rotation X + Degrees Rotation Y + Degrees Rotation Z + Distance M)
                  */
                  StuntScoreHolder =
                          ((InAirSpinPositive / 360) + (InAirPitchPositive / 360) + (InAirRollPositive / 360))
                          *
                          (InAirSpinPositive + InAirPitchPositive + InAirRollPositive + InAirDistance);
                  PC.PlayerReplicationInfo.Score += StuntScoreHolder;
                  StuntScoreHolder = 0;
             }

        }
    }
    bIsOne=False;
    bIsTwo=False;
    bIsThree=False;
    bIsFour=False;
    bIsFive=False;
}

defaultproperties
{
     TierOneThresh = 1
     TierTwoThresh = 2
     TierThreeThresh = 4
     TierFourThresh = 7
     TierFiveThresh = 11

     BaseScoreBonus=50.00000

     DaredevilThreshInAirSpin=100.000000
     DaredevilThreshInAirPitch=100.000000
     DaredevilThreshInAirRoll=100.000000
     DaredevilThreshInAirTime=1.000000
     DaredevilThreshInAirDistance=2.000000
     DaredevilMessageClass=Class'UnrealDemolition.UDStuntMessage'

     NetStartingNow=0

     bIsOne=False
     bIsTwo=False
     bIsThree=False
     bIsFour=False
     bIsFive=False
}
