class UDVech extends ONSWheeledCraft CacheExempt;

/**
 * TODO:
 *     Figure out why the fucking vehicles keep spawning with 0 health
 *
 * Value to tweak: all in default properties, so you can tweak vehicles so some jump less
 * or some do more damage etc...
 * WallCollisionResistance:  change in default properties  higher = less damage
 * JumpTimePauseDuration : Time without jump
 * PsiRateGain: higher it is faster regen is
 * InitialCostBoost: the initial cost when boost button is pushed
 * BoostCostPerTick: the cost per tick clock
 */
  #exec OGJ LOAD FILE=..\Textures\UDHUD.utx


var() float boostAmt;
var() float boostMax;
var() float JumpPower;
var() float SpeedBoost;
var() float JumpTime;
var() float PsiRateGain;    // Affect the regen rate of psi => higher value = faster
var() int JumpTimePauseDuration; // How much time before reallowed to jump
var() int WallCollisionResistance; // Wall collision Diminish damage factor
var() int InitialCostBoost;
var() float BoostCostPerTick;
var() int JumpCost;
var() bool  bBoosting;
var() bool  bJumping; // state (can or cannot jump)
var xEmitter LeftTrail, RightTrail;
var bool bBarrelRollLeft, bBarrelRollRight;

//var Texture psiMeter;
//var Texture dotTexture;

replication
{
    unreliable if( Role<ROLE_Authority )
        UDJump, UDBoost, UDBoostEnd, UDBarrelRoll;

    reliable if( Role==ROLE_Authority )
        boostAmt, bBoosting, bJumping, JumpTime, BoostCostPerTick, InitialCostBoost, bBarrelRollLeft, bBarrelRollRight;
}

simulated function PostBeginPlay()
{

     Super.PostBeginPlay();
     Enable('Timer');
     SetTimer(0.1,true);
}
/**
 * Timer called each .1 seconds
 */
function Timer()
{
    // Temporary fix for the god damn 0 health bug
    // Bastard won't go away, so for now I'll force health
    // Me > Vehicle
    if (Health == 0)
    {
        Health = HealthMax;
    }

    // If there is no driver, the vehicle explodes.
    if (self.Driver == none)
    {
       self.Suicide();
    }

    // slowy gain back PSI
    if (boostAmt < boostMax)
    {
       boostAmt += PsiRateGain;
    }
    else
    {
       boostAmt = boostMax;
    }

    // disable jump if no more psi
    if (bShowChargingBar == true)
       bShowChargingBar = false;

    if (bBoosting == true)
    {
        boostAmt -= BoostCostPerTick;
    }

    // Stop boost if no more psi
    if (boostAmt < 1)
    {
        bBoosting = false;
        UDBoostEnd();
    }

    JumpTime -= 1.;
    if (JumpTime < 0.)
    {
        JumpTime = -1.;
        bJumping = false;
    }
}

simulated function DrawHUD(Canvas C)
{
    local PlayerController PC;

    PC = PlayerController(Controller);
    // Don't draw if we are dead, scoreboard is visible, etc
    if (Health < 1 || PC == None || PC.myHUD == None || PC.MyHUD.bShowScoreboard || PC.myHUD.bHideHUD)
    {
        return;
    }

    C.Style = ERenderStyle.STY_Alpha;
    C.DrawColor = C.MakeColor(255,255,255);
    C.Font = PC.MyHUD.GetFontSizeIndex(C, -1);
    C.SetPos(15, C.ClipY * 0.4 );
    C.DrawText("PSI: " $ boostAmt);
    C.SetPos(15, C.ClipY * 0.43 );
    C.Font = PC.MyHUD.GetFontSizeIndex(C, -2);
    if (bJumping == false)
    {
       if (boostAmt < 5)
       {
           C.DrawColor = C.MakeColor(255,0,0);
           C.DrawText("Jump Needs More PSI");
       }
       else
       {
           C.DrawColor = C.MakeColor(0,255,0);
           C.DrawText("Ready to Jump");
       }
    }
    else
    {
       C.DrawColor = C.MakeColor(255,0,0);
       C.DrawText("Jump Unavailable");
    }
    C.SetPos(15, C.ClipY * 0.46 );
    if (bBoosting == false)
    {
       if (boostAmt < InitialCostBoost)
       {
           C.DrawColor = C.MakeColor(255,0,0);
           C.DrawText("Boost Needs More PSI");
       }
       else
       {
           C.DrawColor = C.MakeColor(0,255,0);
           C.DrawText("Ready to Boost");
       }
    }
    else
    {
        C.DrawColor = C.MakeColor(255,0,0);
        C.DrawText("Boost Unavailable");
    }

    DrawPsiBar(C);
    //super.DrawHUD(C);
}

/**
 * Draw The psibar of the vehicle
 */
function DrawPsiBar(Canvas C)
{
// should use that :
// one texture we clip and the other is the background
// one over the other from the same point
    // Bar
    local int i;
    for (i = 15; i < 23; i += 2)
    {
        C.setPos(i, C.ClipY * 0.50);
        C.SetDrawColor(76, 76, 76);
        C.DrawVertical (i, (boostMax * (C.ClipY * 0.30))/boostMax);
        C.SetDrawColor(0, 243, 76);
        C.DrawVertical (i, (boostAmt * (C.ClipY * 0.30))/boostMax);
    }
}

/**
 * Activate boost
 */
function AltFire(optional float F)
{
    UDBoost();
    bWeaponIsAltFiring = true;
}

/**
 * Activate jump
 */
function Fire(optional float F)
{
    UDJump();
    return;
}

function bool KDriverLeave(bool bForceLeave)
{
    if (bForceLeave) // needed for the Demolition Ball
    {
        return Super.KDriverLeave(bForceLeave);
    }
    return false;
}

simulated function UDJump()
{
    // STOMP DOWN
    if (bVehicleOnGround != true)
    {
        KAddImpulse(vect(0,0,-300000), vect(0,0,0));
        if (Role == ROLE_Authority)
            PlaySound( JumpSound,, 2.5*TransientSoundVolume );
        return;
    }

    // Not enough psi
    if (boostAmt < JumpCost)
    {
        return;
    }

    if (bJumping == false)
    {
        if (JumpTime > 0)
        {
            return;
        }

//        bPushDown = true;
        // JUMP IN THE AIR
        if (bAllowChargingJump == true)
        {
            bJumping = true;
            JumpForce = 5; // ??? unused variable ??
            JumpTime = JumpTimePauseDuration;

            boostAmt -= JumpCost;

            KAddImpulse(vect(0,0,300000), vect(0,0,0));
            if (Role == ROLE_Authority)
                PlaySound( JumpSound,, 2.5*TransientSoundVolume );
            return;
        }
    }
}

simulated function UDBoost()
{
    if (bVehicleOnGround == true && bAllowChargingJump == true && boostAmt > InitialCostBoost && bBoosting == false)
    {
        bBoosting = true;
        boostAmt -= InitialCostBoost;

    if (self.IsA('UDBike') || self.IsA('UDStuntCar'))
        {
            LeftTrail = Spawn(class'UDBoostEffect', self,, self.Location, self.Rotation);
            self.AttachToBone(LeftTrail, 'LrearStrut');

            RightTrail = Spawn(class'UDBoostEffect', self,, self.Location, self.Rotation);
            self.AttachToBone(RightTrail, 'RrearStrut');
        }
    }
    else
    {
        Flip(vector(Driver.Rotation), 1);
    }
}

simulated function UDBoostEnd()
{
    bBoosting = false;

    if (LeftTrail != None)
    {
        LeftTrail.Destroy();
    }

    if (RightTrail != None)
    {
        RightTrail.Destroy();
    }
}

function int LimitPitch(int pitch)
{
    return pitch;
}

simulated event OnDaredevil()
{
    if (DaredevilPoints <= 100)
        return;
}

simulated function KApplyForce(out vector Force, out vector Torque)
{
    if (bBoosting == true && bVehicleOnGround == true)
        Force += vector(Rotation) * SpeedBoost;

    if (bBarrelRollLeft)
    {
        KAddImpulse(vect(0,0,-600000), vector(Rotation+rotator(vect(0,-32,0))));
        KAddImpulse(vect(0,0,600000), vector(Rotation+rotator(vect(0,32,0))));
    }
    if (bBarrelRollRight)
    {
        KAddImpulse(vect(0,0,600000), vector(Rotation+rotator(vect(0,-32,0))));
        KAddImpulse(vect(0,0,-600000), vector(Rotation+rotator(vect(0,32,0))));
    }
    Super.KApplyForce(Force, Torque);
}

/**
 * Should be more elegant
 */
exec simulated function UDBarrelRoll(int dir, bool bEnabled)
{
    if (dir == 0 && bEnabled)
    {
        bBarrelRollLeft = true;
    }
    else if (dir == 1 && bEnabled)
    {
        bBarrelRollRight = true;
    }
    else if (dir == 0 && !bEnabled)
    {
        bBarrelRollLeft = false;
    }
    else if (dir == 1 && !bEnabled)
    {
        bBarrelRollRight = false;
    }
}

function VehicleCeaseFire(bool bWasAltFire)
{
    if (bWasAltFire)
    {
        UDBoostEnd();
    }
}

simulated function Destroyed()
{
    if (LeftTrail != None)
    {
        LeftTrail.Destroy();
    }

    if (RightTrail != None)
    {
        RightTrail.Destroy();
    }

    Super.Destroyed();
}

simulated event KImpact(Actor Other, vector Pos, vector ImpactVel, vector ImpactNorm)
{
    if (Role == ROLE_Authority)
    {
        ImpactInfo.Other = Other;
        ImpactInfo.Pos = Pos;
        ImpactInfo.ImpactVel = ImpactVel;
        ImpactInfo.ImpactNorm = ImpactNorm;
        ImpactInfo.ImpactAccel = KParams.KAcceleration;
        ImpactTicksLeft = ImpactDamageTicks;
    }
}

function addPSI(int increaseAmt)
{
    if ((boostAmt + increaseAmt) > boostMax)
    {
        boostAmt = boostMax;
    }
    else
    {
        boostAmt += increaseAmt;
    }
    return;
}

function addHealth(int healthIncrease)
{
    if ((Health + healthIncrease) > HealthMax)
    {
        Health = HealthMax;
    }
    else
    {
        Health += healthIncrease;
    }
    return;
}

event TakeImpactDamage(float AccelMag)
{
    local int Damage;

    if (UDBall(ImpactInfo.Other) != None)
    {
        Damage = 0;
    }
    else
    {
        Damage = int(VSize(ImpactInfo.Other.Velocity) * 20 * ImpactDamageModifier());
    }
    if (Vehicle(ImpactInfo.Other) != None)
    {
        // Damaging the other car
        // look at the speed of the other car, if bigger, then  take more damage
        TakeDamage(Damage, Vehicle(ImpactInfo.Other), ImpactInfo.Pos, vect(0,0,0), class'DamTypeUD');
    }
    else
    {
        // Hitting a wall
        TakeDamage(int(AccelMag * ImpactDamageModifier())/ WallCollisionResistance , Self, ImpactInfo.Pos, vect(0,0,0), class'DamTypeUD');
    }
    //FIXME - scale sound volume to damage amount
    if (ImpactDamageSounds.Length > 0)
        PlaySound(ImpactDamageSounds[Rand(ImpactDamageSounds.Length-1)],,TransientSoundVolume*2.5);

    if (Health < 0 && (Level.TimeSeconds - LastImpactExplosionTime) > TimeBetweenImpactExplosions)
    {
        VehicleExplosion(Normal(ImpactInfo.ImpactNorm), 0.5);
        LastImpactExplosionTime = Level.TimeSeconds;
    }
}

function Died(Controller Killer, class<DamageType> damageType, vector HitLocation)
{
    if (damageType == none)
       return;

    if (Killer != None)
        PlayerController(Killer).ReceiveLocalizedMessage(class'UDVehicleKillMessage', 7);

    Super.Died(Killer, damageType, HitLocation);
}

defaultproperties
{
     boostAmt=50.000000
     boostMax=50.000000
     JumpPower=300000.000000
     SpeedBoost=450.000000
     JumpTime=-1.000000
     PsiRateGain=0.300000
     JumpTimePauseDuration=10
     WallCollisionResistance=5
     InitialCostBoost=1
     BoostCostPerTick=1.000000
     JumpCost=5
//   psiMeter=Texture'UDHUD.NewHUD.psimeter3'
//   DotTexture=Texture'UDHUD.NewHUD.DotTexture'
     WheelSoftness=0.025000
     WheelPenScale=1.200000
     WheelPenOffset=0.010000
     WheelRestitution=0.100000
     WheelInertia=0.100000
     WheelLongFrictionFunc=(Points=(,(InVal=100.000000,OutVal=1.000000),(InVal=200.000000,OutVal=0.900000),(InVal=10000000000.000000,OutVal=0.900000)))
     WheelLongSlip=0.001000
     WheelLatSlipFunc=(Points=(,(InVal=30.000000,OutVal=0.009000),(InVal=45.000000),(InVal=10000000000.000000)))
     WheelLongFrictionScale=1.700000 //default 1.1
     WheelLatFrictionScale=1.950000  //default 1.35
     WheelHandbrakeSlip=0.010000
     WheelHandbrakeFriction=0.100000
     WheelSuspensionTravel=15.000000
     WheelSuspensionMaxRenderTravel=15.000000
     FTScale=0.030000
     ChassisTorqueScale=0.400000
     MinBrakeFriction=4.000000
     MaxSteerAngleCurve=(Points=((OutVal=25.000000),(InVal=1500.000000,OutVal=11.000000),(InVal=1000000000.000000,OutVal=11.000000)))
     TorqueCurve=(Points=((OutVal=9.000000),(InVal=200.000000,OutVal=10.000000),(InVal=1500.000000,OutVal=11.000000),(InVal=2800.000000)))
     GearRatios(0)=-0.500000
     GearRatios(1)=0.400000
     GearRatios(2)=0.650000
     GearRatios(3)=0.850000
     GearRatios(4)=1.100000
     TransRatio=0.150000
     ChangeUpPoint=2000.000000
     ChangeDownPoint=1000.000000
     LSDFactor=1.000000
     EngineBrakeFactor=0.000100
     EngineBrakeRPMScale=0.100000
     MaxBrakeTorque=20.000000
     SteerSpeed=160.000000
     TurnDamping=35.000000
     StopThreshold=100.000000
     HandbrakeThresh=200.000000
     EngineInertia=0.100000
     IdleRPM=500.000000
     EngineRPMSoundRange=9000.000000
     SteerBoneName="SteeringWheel"
     SteerBoneAxis=AXIS_Z
     SteerBoneMaxAngle=90.000000
     RevMeterScale=4000.000000
     bMakeBrakeLights=True
     BrakeLightOffset(0)=(X=-100.000000,Y=23.000000,Z=7.000000)
     BrakeLightOffset(1)=(X=-100.000000,Y=-23.000000,Z=7.000000)
     BrakeLightMaterial=Texture'EpicParticles.Flares.FlashFlare1'
     DaredevilThreshInAirSpin=180.000000
     DaredevilThreshInAirTime=1.700000
     DaredevilThreshInAirDistance=21.000000
     bDoStuntInfo=True
     bAllowAirControl=True
     bAllowChargingJump=True
     bAllowBigWheels=True
     MaxJumpForce=0.000000
     AirTurnTorque=35.000000
     AirPitchTorque=55.000000
     AirPitchDamping=35.000000
     AirRollTorque=35.000000
     AirRollDamping=35.000000
     FenderBenderSpeed=400.000000
     bHasAltFire=False
     RedSkin=Shader'VMVehicles-TX.RVGroup.RVChassisFinalRED'
     BlueSkin=Shader'VMVehicles-TX.RVGroup.RVChassisFinalBLUE'
     IdleSound=Sound'ONSVehicleSounds-S.RV.RVEng01'
     StartUpSound=Sound'ONSVehicleSounds-S.RV.RVStart01'
     ShutDownSound=Sound'ONSVehicleSounds-S.RV.RVStop01'
     StartUpForce="RVStartUp"
     DestroyedVehicleMesh=StaticMesh'ONSDeadVehicles-SM.RVDead'
     DestructionEffectClass=Class'Onslaught.ONSSmallVehicleExplosionEffect'
     DisintegrationEffectClass=Class'Onslaught.ONSVehDeathRV'
     DisintegrationHealth=0.000000
     DestructionLinearMomentum=(Min=200000.000000,Max=300000.000000)
     DestructionAngularMomentum=(Min=100.000000,Max=150.000000)
     ExplosionDamage=0.000000
     DamagedEffectOffset=(X=60.000000,Y=10.000000,Z=10.000000)
     bEjectPassengersWhenFlipped=False
     ImpactDamageMult=0.001000
     HeadlightCoronaOffset(0)=(X=86.000000,Y=30.000000,Z=7.000000)
     HeadlightCoronaOffset(1)=(X=86.000000,Y=-30.000000,Z=7.000000)
     HeadlightCoronaMaterial=Texture'EpicParticles.Flares.FlashFlare1'
     HeadlightCoronaMaxSize=65.000000
     HeadlightProjectorMaterial=Texture'VMVehicles-TX.RVGroup.RVprojector'
     HeadlightProjectorOffset=(X=90.000000,Z=7.000000)
     HeadlightProjectorRotation=(Pitch=-1000)
     HeadlightProjectorScale=0.300000
     Wheels(0)=SVehicleWheel'Onslaught.ONSRV.RRWheel'

     Wheels(1)=SVehicleWheel'Onslaught.ONSRV.LRWheel'

     Wheels(2)=SVehicleWheel'Onslaught.ONSRV.RFWheel'

     Wheels(3)=SVehicleWheel'Onslaught.ONSRV.LFWheel'

     VehicleMass=3.500000
     bDrawDriverInTP=True
     bDrawMeshInFP=True
     bTeamLocked=False
     bHasHandbrake=True
     bSeparateTurretFocus=True
     DrivePos=(X=2.000000,Z=38.000000)
     ExitPositions(0)=(Y=-165.000000,Z=100.000000)
     ExitPositions(1)=(Y=165.000000,Z=100.000000)
     ExitPositions(2)=(Y=-165.000000,Z=-100.000000)
     ExitPositions(3)=(Y=165.000000,Z=-100.000000)
     EntryRadius=160.000000
     FPCamPos=(X=15.000000,Z=25.000000)
     TPCamDistance=350.000000
     CenterSpringForce="SpringONSSRV"
     TPCamLookat=(X=0.000000,Z=0.000000)
     TPCamWorldOffset=(Z=100.000000)
     DriverDamageMult=0.000000
     VehiclePositionString="in a Derby-Vehicle"
     VehicleNameString="Derby-Vehicle"
     RanOverDamageType=Class'Onslaught.DamTypeRVRoadkill'
     CrushedDamageType=Class'Onslaught.DamTypeRVPancake'
     StolenAnnouncement="Play"
     MaxDesireability=0.400000
     ObjectiveGetOutDist=1500.000000
     HornSounds(0)=Sound'ONSVehicleSounds-S.Horns.Horn06'
     HornSounds(1)=Sound'ONSVehicleSounds-S.Horns.Dixie_Horn'
     GroundSpeed=8000.000000
     HealthMax=300.000000
     Health=300
     bReplicateAnimations=True
     Mesh=SkeletalMesh'ONSVehicles-A.RV'
     SoundVolume=180
     CollisionRadius=100.000000
     CollisionHeight=40.000000
     KParams=KarmaParamsRBFull'Onslaught.ONSRV.KParams0'

}
