class UDHUD extends HudCDeathMatch
    config(User);

var Texture BeaconMat;
var Material BeaconNameMat;
var int MaxBeaconDist;
var color BeaconColor,BeaconNameColor;
var float RXSize,RYSize;
var float BeaconNameBoxX,BeaconNameBoxY;

simulated function DrawCrosshair(Canvas C)
{
}

simulated function DrawHudPassA (Canvas C)
{
    local Pawn RealPawnOwner;

    ZoomFadeOut(C);

    if ( PawnOwner != None )
    {
        if( bShowPersonalInfo )
        {
                if ( Vehicle(PawnOwner) != None && Vehicle(PawnOwner).Driver != None )
                {
                    RealPawnOwner = PawnOwner;
                    PawnOwner = Vehicle(PawnOwner).Driver;
                }

            if (RealPawnOwner != None)
            {
                PawnOwner = RealPawnOwner;

                DrawSpriteWidget( C, HudBorderVehicleHealth );

                //JeT Says: Base this off vehicle health now, instead of player health.
                if (Vehicle(PawnOwner).Health < Vehicle(PawnOwner).HealthMax / 5)
                {
                    HudVehicleHealthALERT.Tints[TeamIndex] = HudColorTeam[TeamIndex];
                    DrawSpriteWidget(C, HudVehicleHealthALERT);
                    HudBorderVehicleHealthIcon.WidgetTexture = Material'HudContent.Generic.HUDPulse';
                }
                else
                    HudBorderVehicleHealthIcon.WidgetTexture = default.HudBorderVehicleHealth.WidgetTexture;

                DrawSpriteWidget(C, HudBorderVehicleHealthIcon);

                if (CurVehicleHealth < LastVehicleHealth )
                    LastDamagedVehicleHealth = Level.TimeSeconds;

                DrawHUDAnimDigit(DigitsVehicleHealth, default.DigitsVehicleHealth.TextureScale, LastDamagedVehicleHealth, 0.8, default.DigitsVehicleHealth.Tints[TeamIndex], HudColorHighLight);
                DrawNumericWidget(C, DigitsVehicleHealth, DigitsBig);

                if (CurVehicleHealth > 999)
                {
                    DigitsVehicleHealth.OffsetX = 220;
                    DigitsVehicleHealth.OffsetY = -35;
                    DigitsVehicleHealth.TextureScale = 0.39;
                }
                else
                {
                    DigitsVehicleHealth.OffsetX = default.DigitsVehicleHealth.OffsetX;
                    DigitsVehicleHealth.OffsetY = default.DigitsVehicleHealth.OffsetY;
                    DigitsVehicleHealth.TextureScale = default.DigitsVehicleHealth.TextureScale;
                }
            }
            RenderBeacons(C);
        }
    }

    UpdateRankAndSpread(C);
    DrawUDamage(C);

    if(bDrawTimer)
        DrawTimer(C);

    HudBorderVehicleHealth.Tints[0] = HudColorRed;
    HudBorderVehicleHealth.Tints[1] = HudColorBlue;

    if( Level.TimeSeconds - LastVoiceGainTime < 0.333 )
        DisplayVoiceGain(C);

    DisplayLocalMessages (C);
}

simulated function DrawSpectatingHud (Canvas C)
{
    local string InfoString;
    local plane OldModulate;
    local float xl,yl,Full, Height, Top, TextTop, MedH, SmallH,Scale;
    local GameReplicationInfo GRI;

    // Hack for tutorials.
    bIsCinematic = IsInCinematic();

    DisplayLocalMessages (C);

    if ( bIsCinematic )
        return;

    OldModulate = C.ColorModulate;

    C.Font = GetMediumFontFor(C);
    C.StrLen("W",xl,MedH);
    Height = MedH;
    C.Font = GetConsoleFont(C);
    C.StrLen("W",xl,SmallH);
    Height += SmallH;

    Full = Height;
    Top  = C.ClipY-8-Full;

    Scale = (Full+16)/128;

    // I like Yellow

    C.ColorModulate.X=255;
    C.ColorModulate.Y=255;
    C.ColorModulate.Z=0;
    C.ColorModulate.W=255;

    // Draw Border

    C.SetPos(0,Top);
    C.SetDrawColor(255,255,255,255);
    C.DrawTileStretched(material'InterfaceContent.SquareBoxA',C.ClipX,Full);
    C.ColorModulate.Z=255;

    TextTop = Top + 4;
    GRI = PlayerOwner.GameReplicationInfo;

    C.SetPos(0,Top-8);
    C.Style=5;
    C.DrawTile(texture'UDHUD.spec_logo',256*Scale,128*Scale,0,0,256,128);
    C.Style=1;

    if ( UnrealPlayer(Owner).bDisplayWinner ||  UnrealPlayer(Owner).bDisplayLoser )
    {
        if ( UnrealPlayer(Owner).bDisplayWinner )
            InfoString = YouveWonTheMatch;
        else
        {
            if ( PlayerReplicationInfo(PlayerOwner.GameReplicationInfo.Winner) != None )
                InfoString = WonMatchPrefix$PlayerReplicationInfo(PlayerOwner.GameReplicationInfo.Winner).PlayerName$WonMatchPostFix;
            else
                InfoString = YouveLostTheMatch;
        }

        C.SetDrawColor(255,255,255,255);
        C.Font = GetMediumFontFor(C);
        C.StrLen(InfoString,XL,YL);
        C.SetPos( (C.ClipX/2) - (XL/2), Top + (Full/2) - (YL/2));
        C.DrawText(InfoString,false);
    }

    else if ( Pawn(PlayerOwner.ViewTarget) != None && Pawn(PlayerOwner.ViewTarget).PlayerReplicationInfo != None )
    {
        // Draw View Target info

        C.SetDrawColor(32,255,32,255);

        if ( C.ClipX < 640 )
            SmallH = 0;
        else
        {
            // Draw "Now Viewing"

            C.SetPos((256*Scale*0.75),TextTop);
            C.DrawText(NowViewing,false);

            // Draw "Score"

            InfoString = GetScoreText();
            C.StrLen(InfoString,Xl,Yl);
            C.SetPos(C.ClipX-10-XL,TextTop);
            C.DrawText(InfoString);
        }

        // Draw Player Name

        C.SetDrawColor(255,255,0,255);
        C.Font = GetMediumFontFor(C);
        C.SetPos((256*Scale*0.75),TextTop+SmallH);
        C.DrawText(Pawn(PlayerOwner.ViewTarget).PlayerReplicationInfo.PlayerName,false);

        // Draw Score

        InfoString = GetScoreValue(Pawn(PlayerOwner.ViewTarget).PlayerReplicationInfo);
        C.StrLen(InfoString,xl,yl);
        C.SetPos(C.ClipX-10-XL,TextTop+SmallH);
        C.DrawText(InfoString,false);

        // Draw Tag Line

        C.Font = GetConsoleFont(C);
        InfoString = GetScoreTagLine();
        C.StrLen(InfoString,xl,yl);
        C.SetPos( (C.ClipX/2) - (XL/2),Top-3-YL);
        C.DrawText(InfoString);
    }
    else
    {
        InfoString = GetInfoString();

        // Draw
        C.SetDrawColor(255,255,255,255);
        C.Font = GetMediumFontFor(C);
        C.StrLen(InfoString,XL,YL);
        C.SetPos( (C.ClipX/2) - (XL/2), Top + (Full/2) - (YL/2));
        C.DrawText(InfoString,false);
    }

    RenderBeacons(C);
    C.ColorModulate = OldModulate;

}

//-beacons-//
simulated function RenderBeacons (Canvas C)
{
    local UDVech V;
    local string Objname;

    if (PlayerOwner!=None)
    {
        ForEach DynamicActors(class'UDVech', V)
        {
            if (UDVech(PlayerOwner.Pawn) != None && V == UDVech(PlayerOwner.Pawn))
                continue;
            if (V.PlayerReplicationInfo == None)
                continue;
            if (PlayerOwner.LineOfSightTo(V))
            {
                BeaconColor = GreenColor;
                BeaconNameColor = GreenColor;
                if (PlayerOwner.PlayerReplicationInfo.bOnlySpectator)
                    Objname = V.PlayerReplicationInfo.PlayerName@"("$V.Health$")";
                else
                    Objname = V.PlayerReplicationInfo.PlayerName;
                RenderOneBeacon ( C, V.Location, Objname, BeaconColor, BeaconNameColor, 44);
            }

        }
    }
}

simulated function RenderOneBeacon (Canvas C, vector TrgLocation, string s, color BeaconColor, color BeaconNameColor, int ExtraHeight)
{
    local Vector HUDCoords, v, l;
    local rotator r;
    local float xp, yp, scale;
    

    C.DrawColor = BeaconColor;
    C.Font = GetFontSizeIndex(C,-4);
    HUDCoords=TrgLocation;
    HUDCoords.Z += ExtraHeight;
    l = HUDCoords;
    HUDCoords=C.WorldToScreen(HUDCoords);
    if ( HUDCoords.Z >= 1.00 )
        return;
    C.GetCameraLocation(v,r);
    scale=fclamp(45.0/sqrt(vsize(l-v)*tan(level.GetLocalPlayerController().FovAngle*pi/360)),0.5,1.0);
    C.SetPos( HUDCoords.X - (RXSize / 2)*scale, HUDCoords.Y - RYSize*scale);
    C.DrawTile( BeaconMat, RXSize*scale, RYSize*scale, 0.0, 0.0, BeaconMat.USize, BeaconMat.VSize);

    if (s != "")
    {
        C.DrawColor = BeaconNameColor;
        C.StrLen(s,xp,yp);  
        xp *= 0.5;          
        if (HUDCoords.X + xp < C.ClipX) 
        {     
            C.SetPos( HUDCoords.X - xp - BeaconNameBoxX, HUDCoords.Y - RYSize*scale - yp - BeaconNameBoxY);
            C.DrawTileStretched( BeaconNameMat, xp*2 + BeaconNameBoxX*2, yp + BeaconNameBoxY*2);
            C.DrawColor = WhiteColor;
            C.SetPos( HUDCoords.X - xp, HUDCoords.Y - RYSize*scale - yp);
            C.DrawTextClipped(s);
        }     
    }
    C.curx = HUDCoords.X;
}

defaultproperties
{
     BeaconMat=Texture'TeamSymbols.TeamBeaconT'
     BeaconNameMat=Texture'InterfaceContent.Menu.ScoreBoxA'
     MaxBeaconDist=6000
     RXSize=16.000000
     RYSize=16.000000
     BeaconNameBoxX=10.000000
     BeaconNameBoxY=2.000000
     DigitsVehicleHealth=(PosX=0.000000)
     HudVehicleHealthALERT=(PosX=0.000000)
     HudBorderVehicleHealth=(PosX=0.000000)
     HudBorderVehicleHealthIcon=(PosX=0.000000)
     WonMatchPostFix=" is the Derby Champion!"
     WaitingToSpawn="Press [Fire] to Join the Derby!"
     AtMenus="Press [ESC] to Close Menu"
     YouveWonTheMatch="You've Won the Derby Match!"
     YouveLostTheMatch="You've Lost the Derby Match."
     NowViewing="Now Viewing:"
     ScoreText="Score:"
}
