class UDMutSumo extends DMMutator
    CacheExempt;

simulated function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
    local UDSumo LMSGame;

    LMSGame = UDSumo(Level.Game);

    if(LMSGame == None)
    {
        bSuperRelevant = 0;
        return true;
    }

    if ( Other.IsA('UDVech') )
        UDVech(Other).ImpactDamageMult = 0.00;

    // Remove conventional weapon pickups. Leave super weapons, all ammo etc.
    if ( Other.IsA('Pickup') )
    {
        if (!LMSGame.bAllowPickups)
            return !Level.bStartup;

        if (Other.IsA('AdrenalinePickup') && !LMSGame.bAllowAdrenaline)
            return false;

        if( Other.IsA('WeaponPickup') )
        {
            if( LMSGame.bAllowSuperweapons && (Other.IsA('PainterPickup') || Other.IsA('RedeemerPickup')) )
            {
                bSuperRelevant = 0;
                return true;
            }
            else
            {
                return !Level.bStartup;
            }
        }
        else
        {
            bSuperRelevant = 0;
            return true;
        }
    }

    // Hide all weapon bases apart from super weapons
    if ( Other.IsA('xPickupBase') )
    {
        if ( Other.IsA('xWeaponBase') )
        {
            if( LMSGame.bAllowSuperweapons && (xWeaponBase(Other).WeaponType == class'Painter' || xWeaponBase(Other).WeaponType == class'Redeemer') )
                Other.bHidden = false;
            else
            {
                Other.bHidden = true;
            }
        }
        else if (!LMSGame.bAllowPickups)
        {
            Other.bHidden = true;
        }

    }

    bSuperRelevant = 0;
    return true;
}

defaultproperties
{
}
